## clfft 2.10.0

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

if( WIN32 )
	# We require 2.8.3 for windows because of a bug in cmake that prevented vs2010 from generating
	# executables properly with multiple periods
	cmake_minimum_required( VERSION 2.8.3 )
else( )
	cmake_minimum_required( VERSION 2.6 )
endif( )

if( CMAKE_GENERATOR MATCHES "NMake" )
	option( NMAKE_COMPILE_VERBOSE "Print compile and link strings to the console" OFF )
	if( NMAKE_COMPILE_VERBOSE )
		set( CMAKE_START_TEMP_FILE "" )
		set( CMAKE_END_TEMP_FILE "" )
		set( CMAKE_VERBOSE_MAKEFILE 1 )
	endif( )
endif( )

# This becomes the name of the solution file
project( clFFT )

# Define a version for the code
if( NOT DEFINED CLFFT_VERSION_MAJOR )
    set( CLFFT_VERSION_MAJOR 2 )
endif( )

if( NOT DEFINED CLFFT_VERSION_MINOR )
    set( CLFFT_VERSION_MINOR 10 )
endif( )

if( NOT DEFINED CLFFT_VERSION_PATCH )
    set( CLFFT_VERSION_PATCH 0 )
endif( )

set( CLFFT_VERSION "${CLFFT_VERSION_MAJOR}.${CLFFT_VERSION_MINOR}.${CLFFT_VERSION_PATCH}")

# This is incremented when the ABI to the library changes
set( CLFFT_SOVERSION 2 )

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR} )

# On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files'
# Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
if( WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
endif( )

# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does not use CMAKE_BUILD_TYPE
if( NOT MSVC_IDE AND NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE )
endif()

# Options that the user or driver program can set to control various components of the build
option( BUILD_RUNTIME "Build the FFT runtime library" ON )
option( BUILD_CLIENT "Build a command line clFFT client program with a variety of configurable parameters (dependency on Boost)" OFF )
option( BUILD_TEST "Build the library testing suite (dependency on google test, Boost, and FFTW)" OFF )
option( BUILD_LOADLIBRARIES "Build the optional dynamic load libraries that the FFT runtime will search for" ON )
option( BUILD_SHARED_LIBS "Build shared libraries." ON)
option( BUILD_EXAMPLES "Build examples." ON)
option( BUILD_CALLBACK_CLIENT "Build a command line clFFT client program that tests callback functionality (dependency on Boost)" OFF )

# If BOOST_ROOT is defined as an environment value, use that value and cache it so it's visible in the cmake-gui.
# Otherwise, create a sensible default that the user can change
if( DEFINED ENV{BOOST_ROOT} )
	set( BOOST_ROOT $ENV{BOOST_ROOT} CACHE PATH "Environment variable defining the root of the Boost installation" )
endif( )

# Currently, linux has a problem outputing both narrow and wide characters,
# which happens in our client because openCL only supports narrow characters
if( WIN32 )
	option( UNICODE "Build with Unicode Support" ON )
	if( UNICODE )
		message( STATUS "UNICODE build" )
	endif( )
else()
	set( UNICODE OFF )
	message( STATUS "UNICODE feature disabled on linux" )
endif()

if( MSVC_IDE )
    set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )

	set( BUILD64 ${CMAKE_CL_64} )
else()
	option( BUILD64 "Build a 64-bit product" ON )

	if( IS_DIRECTORY ${PROJECT_SOURCE_DIR}/tests )
		option( CODE_COVERAGE "Build makefiles with code coverage instrumentation" OFF )
		if( CODE_COVERAGE )
			message( STATUS "Code coverage instrumentation on" )
		endif()
	endif()
endif()

# These variables are meant to contain string which should be appended to the installation paths
# of library and executable binaries, respectively.  They are meant to be user configurable/overridable.
set( SUFFIX_LIB_DEFAULT "" )
set( SUFFIX_BIN_DEFAULT "" )

# Modify the global find property to help us find libraries like Boost in the correct paths for 64-bit
# Essentially, find_library calls will look for /lib64 instead of /lib; works for windows and linux
if( BUILD64 )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE )
	message( STATUS "64bit build - FIND_LIBRARY_USE_LIB64_PATHS TRUE" )
    if( NOT APPLE )
      set( SUFFIX_LIB_DEFAULT "64" )
    endif()
else( )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE )
	message( STATUS "32bit build - FIND_LIBRARY_USE_LIB64_PATHS FALSE" )
endif( )

set( SUFFIX_LIB ${SUFFIX_LIB_DEFAULT} CACHE STRING "String to append to 'lib' install path" )
set( SUFFIX_BIN ${SUFFIX_BIN_DEFAULT} CACHE STRING "String to append to 'bin' install path" )

# Useful variables to configure FindBoost.cake
# set( Boost_USE_MULTITHREADED ON )
# set( Boost_DETAILED_FAILURE_MSG   ON )
# set( Boost_DEBUG ON )
# set( Boost_NO_SYSTEM_PATHS ON )

# Client is built only if boost is found; on windows, we need vs10 or higher
# Find Boost on the system, and configure the type of boost build we want
if( NOT DEFINED Boost_USE_STATIC_LIBS )
   set( Boost_USE_STATIC_LIBS   ON )
endif( )

if( NOT DEFINED Boost_USE_STATIC_RUNTIME )
   set( Boost_USE_STATIC_RUNTIME OFF )
endif( )

# This will define Boost_FOUND
find_package( Boost 1.33.0 COMPONENTS program_options )
if( Boost_FOUND )
   message( STATUS "Boost_PROGRAM_OPTIONS_LIBRARY: ${Boost_PROGRAM_OPTIONS_LIBRARY}" )
else( )
   message( WARNING "Try setting Boost_DEBUG and Boost_DETAILED_FAILURE_MSG for more information" )
endif( )

# This will define OPENCL_FOUND
find_package( OpenCL )

# This will define FFTW_FOUND
find_package( FFTW )

# Enable building of the clACML client if both requested and all dependencies are found
if( BUILD_CLIENT AND Boost_FOUND )
	set( FFT_CLIENT ON )
else( )
	set( FFT_CLIENT OFF )
endif( )

# Enable building of the googletest unit test framework if requested and all dependencies are found
set( UNIT_TEST OFF )
if( BUILD_TEST )
    include(gtest.cmake)
    if( GTEST_FOUND AND Boost_FOUND AND FFTW_FOUND )
		set( UNIT_TEST ON )
	else( )
		message( "GoogleTest unit testing will NOT be built" )
    endif( )
endif( )

# Enable building of the callback client if requested and all dependencies are found
if( BUILD_CALLBACK_CLIENT AND Boost_FOUND AND FFTW_FOUND )
	set( FFT_CALLBACK_CLIENT ON )
else( )
	set( FFT_CALLBACK_CLIENT OFF )
endif( )

# FFLAGS depend on the compiler, grab the compiler name from the path
get_filename_component( C_COMPILER_NAME ${CMAKE_C_COMPILER} NAME_WE )
# message( "C_COMPILER_NAME: " ${C_COMPILER_NAME} )
# message( "CMAKE_C_COMPILER: " ${CMAKE_C_COMPILER} )

if(APPLE)
    # avoid warning on newer cmake versions
    set(CMAKE_MACOSX_RPATH 0)
endif()

# Set common compile and link options
if( MSVC )
	# Following options for nMake
	message( STATUS "Detected MSVS Ver: " ${MSVC_VERSION} )

	# CMake sets huge stack frames for windows, for whatever reason.  We go with compiler default.
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}" )

elseif( CMAKE_COMPILER_IS_GNUCXX )
	message( STATUS "Detected GNU fortran compiler." )
	EXEC_PROGRAM( ${CMAKE_CXX_COMPILER} ARGS --version OUTPUT_VARIABLE vnum )
	STRING(REGEX REPLACE ".*([0-9])\\.([0-9])\\.([0-9]).*" "\\1\\2\\3" vnum ${vnum})
	if( ${vnum} STREQUAL "452" )
		# we only want c++0x if we're using gcc 4.5.2
		set( CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}" )
	endif()

	set( CMAKE_CXX_FLAGS "-pthread ${CMAKE_CXX_FLAGS}" )
	set( CMAKE_C_FLAGS "-pthread ${CMAKE_C_FLAGS}" )

	# For linux debug builds, define the same preprocessing symbols as win to keep it simple
	if( CMAKE_BUILD_TYPE MATCHES "Debug" )
		add_definitions( "/D_DEBUG" )
	endif( )

	if( BUILD64 )
		set( CMAKE_CXX_FLAGS "-m64 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m64 ${CMAKE_C_FLAGS}" )
	else( )
		set( CMAKE_CXX_FLAGS "-m32 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}" )
	endif( )

    if( CODE_COVERAGE )
        set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
        set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
    endif()
endif( )

# If UNICODE is defined for microsoft compilers, pass extra definitions
if( MSVC AND UNICODE )
	add_definitions( "/DUNICODE /D_UNICODE" )
endif( )

# Print out compiler flags for viewing/debug
message( STATUS "CMAKE_CXX_COMPILER flags: " ${CMAKE_CXX_FLAGS} )
message( STATUS "CMAKE_CXX_COMPILER debug flags: " ${CMAKE_CXX_FLAGS_DEBUG} )
message( STATUS "CMAKE_CXX_COMPILER release flags: " ${CMAKE_CXX_FLAGS_RELEASE} )
message( STATUS "CMAKE_CXX_COMPILER relwithdebinfo flags: " ${CMAKE_CXX_FLAGS_RELWITHDEBINFO} )
message( STATUS "CMAKE_EXE_LINKER link flags: " ${CMAKE_EXE_LINKER_FLAGS} )

if(NOT BUILD_SHARED_LIBS)
  set(CLFFT_STATIC ON)
endif()
# configure a header file to pass the CMake version settings to the source, and package the header files in the output archive
configure_file( "${PROJECT_SOURCE_DIR}/include/clFFT.version.h.in" "${PROJECT_BINARY_DIR}/include/clFFT.version.h" )
install( FILES
			"${PROJECT_BINARY_DIR}/include/clFFT.version.h"
			"include/clFFT.h"
			"include/clAmdFft.h"
			"include/clAmdFft.version.h"
		DESTINATION
			"./include" )

# Recurse into subdirectory and start building files there
if( BUILD_RUNTIME AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/library" )
	add_subdirectory( library )
else()
	message( "Runtime library will NOT be built" )
endif( )

if( IS_DIRECTORY "${PROJECT_SOURCE_DIR}/scripts/perf" )
	add_subdirectory( scripts/perf )
endif( )

# We only want to build the following if the user options are set
if( FFT_CLIENT AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/client" )
	add_subdirectory( client )
else( )
	message( "FFT clients will NOT be built" )
endif( )

# Recurse into subdirectory and start building files there
if( BUILD_LOADLIBRARIES AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/statTimer" )
	add_subdirectory( statTimer )
else()
	message( "LoadLibraries will NOT be built" )
endif( )

if( UNIT_TEST AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/tests" )
	# enable_testing( )
	add_subdirectory( tests )
else( )
	message( "GoogleTest unit tests will NOT be built" )
endif( )

# We only want to build the following if the user options are set
if( FFT_CALLBACK_CLIENT AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/callback-client" )
	add_subdirectory( callback-client )
else( )
	message( "FFT callback client will NOT be built" )
endif( )

if( BUILD_EXAMPLES )
    add_subdirectory( examples )
endif()

if(WIN32)
  set(destdir CMake)
else()
  set(destdir lib${SUFFIX_LIB}/cmake/clFFT)
endif()
string(REGEX REPLACE "[^/]+" ".." reldir "${destdir}")
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/clFFTConfigVersion.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfigVersion.cmake
  @ONLY)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/clFFTConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfig.cmake
  @ONLY)
install(EXPORT Library DESTINATION ${destdir} FILE clFFTTargets.cmake)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfigVersion.cmake

=== src/library/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

# List the names of common files to compile across all platforms
set( clFFT.Source	transform.cpp
								accessors.cpp
								plan.cpp
								repo.cpp
								generator.stockham.cpp
								generator.transpose.gcn.cpp
								generator.transpose.nonsquare.cpp
								generator.transpose.square.cpp
								generator.copy.cpp
								lifetime.cpp
								fft_binary_lookup.cpp
								md5sum.c
								action.cpp
								stdafx.cpp )

# Windows only uses dllmain
if( MSVC )
	set( clFFT.Source ${clFFT.Source} dllmain.cpp )
endif( )

set( clFFT.Headers	private.h
					action.h
					repo.h
					plan.h
					lock.h
					mainpage.h
					generator.h
					generator.stockham.h
					generator.transpose.gcn.h
					generator.transpose.nonsquare.h
					generator.transpose.square.h
					fft_binary_lookup.h
					md5sum.h
					../include/stdafx.h
					../include/unicode.compatibility.h
					../include/targetver.h
					../include/clAmdFft.h
					../include/clFFT.h )

set( clFFT.Files ${clFFT.Source} ${clFFT.Headers} )

# For a rainy day, add pre-compiled header support
#if( MSVC )
#	if (USE_MSVC_PCH)

#		set_source_files_properties(LungAnalysisPCH.cxx
#			PROPERTIES
#			COMPILE_FLAGS "/YcLungAnalysisPCH.h"
#			)
#		foreach( src_file ${UPMC_LA_SRCS} )
#			set_source_files_properties(
#				${src_file}
#				PROPERTIES
#				COMPILE_FLAGS "/YuLungAnalysisPCH.h"
#				)
#		endforeach( src_file ${UPMC_LA_SRCS} )

#		list(APPEND UPMC_LA_SRCS LungAnalysisPCH.cxx)
#		list(APPEND UPMC_LA_HDRS LungAnalysisPCH.h)

#	endif(USE_MSVC_PCH)
#endif (MSVC)

#	add_definitions( ${Boost_LIB_DIAGNOSTIC_DEFINITIONS} )
add_definitions( "/DCLFFT_EXPORTS" )

# Include standard OpenCL headers
include_directories( ${OPENCL_INCLUDE_DIRS} ${PROJECT_BINARY_DIR}/include ../include )

add_library( clFFT ${clFFT.Files} )
target_link_libraries( clFFT ${OPENCL_LIBRARIES} ${CMAKE_DL_LIBS} )

set_target_properties( clFFT PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( clFFT PROPERTIES SOVERSION ${CLFFT_SOVERSION} )
set_target_properties( clFFT PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

if( CMAKE_COMPILER_IS_GNUCC )
    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/clFFT.pc.in
                    ${CMAKE_CURRENT_BINARY_DIR}/clFFT.pc @ONLY )

    install( FILES ${CMAKE_CURRENT_BINARY_DIR}/clFFT.pc
             DESTINATION lib${SUFFIX_LIB}/pkgconfig )
endif( )

# CPack configuration; include the executable into the package
install( TARGETS clFFT
        EXPORT Library
        RUNTIME DESTINATION bin${SUFFIX_BIN}
        LIBRARY DESTINATION lib${SUFFIX_LIB}
        ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
        )

=== src/tests/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


# List the names of the files to compile
set( clFFT.Test.Source
	 test_constants.cpp
	 buffer_memory.cpp
	 buffer.cpp
	 unit_test.cpp
	 accuracy_test_common.cpp
	 accuracy_test_pow2.cpp
	 accuracy_test_pow3.cpp
	 accuracy_test_pow5.cpp
	 accuracy_test_pow7.cpp
	 accuracy_test_mixed_radices.cpp
	 accuracy_test_random.cpp
	 accuracy_test_mixed_callback.cpp
	 accuracy_test_pow2_precallback.cpp
	 accuracy_test_pow3_precallback.cpp
	 accuracy_test_pow5_precallback.cpp
	 accuracy_test_pow7_precallback.cpp
	 accuracy_test_postcallback.cpp
	 gtest_main.cpp
	 ${PROJECT_SOURCE_DIR}/client/openCL.misc.cpp
	 c-compliance.c
   )

set( clFFT.Test.Headers
	${PROJECT_SOURCE_DIR}/include/clFFT.h
	${PROJECT_SOURCE_DIR}/include/unicode.compatibility.h
	${PROJECT_SOURCE_DIR}/include/convenienceFunctions.h
	${PROJECT_SOURCE_DIR}/library/private.h
	${PROJECT_SOURCE_DIR}/client/openCL.misc.h
	accuracy_test_common.h
	test_constants.h
	buffer_memory.h
	buffer.h
	cl_transform.h
	fftw_transform.h
	typedefs.h
  )

set( clFFT.Test.Files ${clFFT.Test.Source} ${clFFT.Test.Headers} )

set( LD_PTHREAD "" )
if( MINGW )
    # -std=c++0x causes g++ to go into strict ANSI mode, which doesn't declare non-standard functions
    # Googletest for mingw appears to have a dependency on _stricmp and off64_t
	set( CMAKE_CXX_FLAGS "-std=gnu++0x ${CMAKE_CXX_FLAGS}" )
elseif( CMAKE_COMPILER_IS_GNUCXX )
	set( CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}" )
	set( LD_PTHREAD "-lpthread" )
elseif( APPLE )
	set( CMAKE_CXX_FLAGS "-std=c++11 -stdlib=libc++ ${CMAKE_CXX_FLAGS}" )
	add_definitions( -DGTEST_USE_OWN_TR1_TUPLE )
endif( )

# Include standard OpenCL headers
include_directories( ${Boost_INCLUDE_DIRS} ${GTEST_INCLUDE_DIRS} ${FFTW_INCLUDE_DIRS} ${OPENCL_INCLUDE_DIRS}  ${PROJECT_BINARY_DIR}/include ${PROJECT_SOURCE_DIR}/include )

add_executable( Test ${clFFT.Test.Files} )

# If the runtime is being built by the project, use it, otherwise link to a runtime library specified in the install prefix
if( BUILD_RUNTIME )
	target_link_libraries( Test clFFT ${Boost_LIBRARIES} ${GTEST_LIBRARIES} ${FFTW_LIBRARIES} ${OPENCL_LIBRARIES} ${LD_PTHREAD} ${CMAKE_DL_LIBS})
else( )
	# Search for 64bit libs if FIND_LIBRARY_USE_LIB64_PATHS is set to true in the global environment, 32bit libs else
	get_property( LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS )
	if( LIB64 )
		set( clFFT.library "${CMAKE_INSTALL_PREFIX}/lib64" )
	else( )
		set( clFFT.library "${CMAKE_INSTALL_PREFIX}/lib32" )
	endif( )

	if( WIN32 )
		set( clFFT.library "${clFFT.library}/import/clFFT${CMAKE_STATIC_LIBRARY_SUFFIX}" )
	else( )
		set( clFFT.library "${clFFT.library}/${CMAKE_SHARED_LIBRARY_PREFIX}clFFT${CMAKE_SHARED_LIBRARY_SUFFIX}" )
	endif( )

	target_link_libraries( Test ${clFFT.library} ${Boost_LIBRARIES} ${GTEST_LIBRARIES} ${FFTW_LIBRARIES} ${OPENCL_LIBRARIES} ${LD_PTHREAD} ${CMAKE_DL_LIBS})

endif( )

# The following set_target_properties is to get around a bug in cmake 2.8.2, where the suffix after the first '.' is dropped
IF( (MSVC_VERSION VERSION_EQUAL 1600) AND (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} VERSION_LESS 2.8.3) )
	message( STATUS "Detected vs2010 and Cmake version less than 2.8.3; renaming Test with underscores " )
	set_target_properties( Test PROPERTIES OUTPUT_NAME "clFFT_Test" )
ENDIF( )

set_target_properties( Test PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( Test PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

=== debian/changelog ===
clfft (2.10.0-1) unstable; urgency=medium

  * Release to unstable.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 21 Jan 2016 18:25:15 +0000

clfft (2.10.0-1~exp1) experimental; urgency=medium

  * d/gbp.conf: use upstream tag format.
  * d/rules: use DEB_TARGET_MULTIARCH for multiarch paths.
  * d/rules: conditionally build examples on nocheck.
  * Use d/clean to remove doxygen build artefacts.
  * Install sample code via examples file.
  * Update patch queue:
    - Drop Fix-examples-install-target.patch, use dh instead.
    - Drop fix-docs-output.patch, applied upstream.
    - Drop restore-missing-install-targets.patch, fixed upstream.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 14 Jan 2016 19:38:51 +0000

clfft (2.8-3) unstable; urgency=medium

  * Add patch enabling support for kFreeBSD.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 05 Dec 2015 11:32:45 +0000

## clfft 2.10.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 endif( )
 
 if( NOT DEFINED CLFFT_VERSION_PATCH )
-    set( CLFFT_VERSION_PATCH 0 )
+    set( CLFFT_VERSION_PATCH 1 )
 endif( )
 
 set( CLFFT_VERSION "${CLFFT_VERSION_MAJOR}.${CLFFT_VERSION_MINOR}.${CLFFT_VERSION_PATCH}")

=== debian/changelog ===
clfft (2.10.1-1) unstable; urgency=medium

  * New upstream release.
  * d/gbp.conf: change packaging branch to debian/master (DEP-14).
  * libclfft-dev: add install dependency on opencl-dev.
  * Use secure VCS-Git URI.
  * Bump standards version to 3.9.7, no changes required.
  * d/control: cme fix, wrap and sort.
  * d/copyright: cme fix, wrap and sort, update dates.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 16 Mar 2016 12:06:05 +0000

## clfft 2.10.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 endif( )
 
 if( NOT DEFINED CLFFT_VERSION_PATCH )
-    set( CLFFT_VERSION_PATCH 1 )
+    set( CLFFT_VERSION_PATCH 2 )
 endif( )
 
 set( CLFFT_VERSION "${CLFFT_VERSION_MAJOR}.${CLFFT_VERSION_MINOR}.${CLFFT_VERSION_PATCH}")

=== src/cuFFT-client/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

cmake_minimum_required(VERSION 2.8)
find_package(CUDA REQUIRED)

#  client
set( cuFFT-client.Source	cuFFT-client.cpp )

set( cuFFT-client.Files ${cuFFT-client.Source} )

# Pass options to NVCC
set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS}; -gencode arch=compute_20,code=sm_20; -gencode arch=compute_30,code=sm_30; -gencode arch=compute_35,code=sm_35; -gencode arch=compute_37,code=sm_37; -gencode arch=compute_50,code=sm_50; -gencode arch=compute_52,code=sm_52)

include_directories( ./ ../common/inc/ )

CUDA_ADD_EXECUTABLE( cuFFT-client ${cuFFT-client.Files} )

CUDA_ADD_CUFFT_TO_TARGET( cuFFT-client )

target_link_libraries( cuFFT-client ${CUDA_LIBRARIES})

# Set output directory to bin
if( MSVC )
	set(CUDA_GENERATED_OUTPUT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/${BITNESS})
else()
	set(CUDA_GENERATED_OUTPUT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/${BITNESS}/${CMAKE_BUILD_TYPE})
endif()

=== debian/changelog ===
clfft (2.10.2-1) unstable; urgency=medium

  * New upstream release.
  * Add patch enabling support for GNU/Hurd.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 30 Mar 2016 15:35:14 +0100

=== debian/control ===
Source: clfft
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
           Jerome Kieffer <jerome.kieffer@esrf.fr>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.7
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clfft.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/clfft.git
Homepage: https://github.com/clMathLibraries/clFFT

Package: libclfft-bin
Architecture: any
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libclfft2 (= ${binary:Version})
Description: OpenCL FFT library (executables)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT executables.

Package: libclfft-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libclfft2 (= ${binary:Version}),
         ocl-icd-opencl-dev | opencl-dev
Suggests: libclfft-doc
Description: OpenCL FFT library (development files)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT development files.

Package: libclfft-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Description: OpenCL FFT library (documentation)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT documentation.

Package: libclfft2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL FFT library (shared library)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT shared library.

Package: libclfft2-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: ${misc:Depends},
         libclfft2 (= ${binary:Version})
Description: OpenCL FFT library (debugging symbols)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Common build options.
CMAKE_BUILD_OPTIONS = \
	-DBUILD_RUNTIME=ON \
	-DBUILD_CLIENT=ON \
	-DBUILD_TEST=OFF \
	-DBUILD_LOADLIBRARIES=OFF \
	-DBUILD_SHARED_LIBS=ON \
	-DSUFFIX_LIB="/$(DEB_TARGET_MULTIARCH)"

# Disable build of examples if no check requested.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
CMAKE_BUILD_OPTIONS += -DBUILD_EXAMPLES=ON
else
CMAKE_BUILD_OPTIONS += -DBUILD_EXAMPLES=OFF
endif

%:
	dh $@ --parallel \
		--sourcedirectory=src \
		--dbg-package=libclfft2-dbg

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS)

override_dh_auto_build-indep:
	cd docs/ && doxygen clFFT.doxy

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress-indep:
	dh_compress --indep --exclude=examples

## clfft 2.12.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -40,11 +40,11 @@
 endif( )
 
 if( NOT DEFINED CLFFT_VERSION_MINOR )
-    set( CLFFT_VERSION_MINOR 10 )
+    set( CLFFT_VERSION_MINOR 12 )
 endif( )
 
 if( NOT DEFINED CLFFT_VERSION_PATCH )
-    set( CLFFT_VERSION_PATCH 2 )
+    set( CLFFT_VERSION_PATCH 0 )
 endif( )
 
 set( CLFFT_VERSION "${CLFFT_VERSION_MAJOR}.${CLFFT_VERSION_MINOR}.${CLFFT_VERSION_PATCH}")

=== src/library/CMakeLists.txt ===
--- 
+++ 
@@ -21,13 +21,13 @@
 								repo.cpp
 								generator.stockham.cpp
 								generator.transpose.gcn.cpp
-								generator.transpose.nonsquare.cpp
-								generator.transpose.square.cpp
+								generator.transpose.cpp
+								action.transpose.cpp
 								generator.copy.cpp
 								lifetime.cpp
 								fft_binary_lookup.cpp
 								md5sum.c
-								action.cpp
+								enqueue.cpp
 								stdafx.cpp )
 
 # Windows only uses dllmain
@@ -44,8 +44,8 @@
 					generator.h
 					generator.stockham.h
 					generator.transpose.gcn.h
-					generator.transpose.nonsquare.h
-					generator.transpose.square.h
+					generator.transpose.h
+					action.transpose.h
 					fft_binary_lookup.h
 					md5sum.h
 					../include/stdafx.h

=== debian/changelog ===
clfft (2.12.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop Enable-support-for-kFreeBSD.patch, applied upstream.
  * Drop -dbg package in favor of autogenerated -dbgsym.
  * Bump standards version to 3.9.8, no changes required.
  * d/rules: simplify formatting.
  * Add upstream metadata.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 27 Apr 2016 00:49:53 +0100

## clfft 2.12.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 endif( )
 
 if( NOT DEFINED CLFFT_VERSION_PATCH )
-    set( CLFFT_VERSION_PATCH 0 )
+    set( CLFFT_VERSION_PATCH 1 )
 endif( )
 
 set( CLFFT_VERSION "${CLFFT_VERSION_MAJOR}.${CLFFT_VERSION_MINOR}.${CLFFT_VERSION_PATCH}")

=== debian/changelog ===
clfft (2.12.1-1) unstable; urgency=medium

  * New upstream release. 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 04 Jun 2016 17:40:44 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libboost-program-options-dev,
                ocl-icd-opencl-dev | opencl-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clfft.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/clfft.git
 Homepage: https://github.com/clMathLibraries/clFFT
@@ -108,27 +108,3 @@
    * Supports single and double precision floating point formats.
  .
  This package provides the clFFT shared library.
-
-Package: libclfft2-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Priority: extra
-Depends: ${misc:Depends},
-         libclfft2 (= ${binary:Version})
-Description: OpenCL FFT library (debugging symbols)
- The clFFT library is an open source OpenCL library implementation of discrete 
- Fast Fourier Transforms, which:
- .
-   * Provides a fast and accurate platform for calculating discrete FFTs.
-   * Works on CPU or GPU backends.
-   * Supports in-place or out-of-place transforms.
-   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
-     than 1.
-   * Supports planar (real and complex components in separate arrays) and 
-     interleaved (real and complex components as a pair contiguous in memory) 
-     formats.
-   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
-   * Supports single and double precision floating point formats.
- .
- This package provides the clFFT debugging symbols.

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 # Common build options.
-CMAKE_BUILD_OPTIONS = \
+BUILD_OPTIONS = \
 	-DBUILD_RUNTIME=ON \
 	-DBUILD_CLIENT=ON \
 	-DBUILD_TEST=OFF \
@@ -21,18 +21,17 @@
 
 # Disable build of examples if no check requested.
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-CMAKE_BUILD_OPTIONS += -DBUILD_EXAMPLES=ON
+BUILD_OPTIONS += -DBUILD_EXAMPLES=ON
 else
-CMAKE_BUILD_OPTIONS += -DBUILD_EXAMPLES=OFF
+BUILD_OPTIONS += -DBUILD_EXAMPLES=OFF
 endif
 
 %:
 	dh $@ --parallel \
-		--sourcedirectory=src \
-		--dbg-package=libclfft2-dbg
+		--sourcedirectory=src
 
 override_dh_auto_configure:
-	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS)
+	dh_auto_configure -- $(BUILD_OPTIONS)
 
 override_dh_auto_build-indep:
 	cd docs/ && doxygen clFFT.doxy
